
// RANSAC_LineFittingDlg.cpp : implementation file
//

#include "stdafx.h"
#include "RANSAC_LineFitting.h"
#include "RANSAC_LineFittingDlg.h"

#include "RANSAC_LineFittingAlgorithm.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CRANSAC_LineFittingDlg dialog
CRANSAC_LineFittingDlg::CRANSAC_LineFittingDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CRANSAC_LineFittingDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CRANSAC_LineFittingDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
}

BEGIN_MESSAGE_MAP(CRANSAC_LineFittingDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON_LINE_FITTING, &CRANSAC_LineFittingDlg::OnBnClickedButtonLineFitting)
END_MESSAGE_MAP()


// CRANSAC_LineFittingDlg message handlers

BOOL CRANSAC_LineFittingDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// TODO: Add extra initialization here

	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CRANSAC_LineFittingDlg::OnPaint()
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CRANSAC_LineFittingDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}


void CRANSAC_LineFittingDlg::OnBnClickedButtonLineFitting()
{
	// TODO: Add your control notification handler code here

	int no_data = 500;
	sPoint *data = new sPoint[no_data];

	for (int i=0; i<no_data; ++i) {
		if (i%2) {
			data[i].x = i + 20.*rand()/RAND_MAX;
			data[i].y = i + 20.*rand()/RAND_MAX;
		}
		else {
			data[i].x = 10 + 500.*rand()/RAND_MAX;
			data[i].y = 10 + 500.*rand()/RAND_MAX;
		}
	}

	CDC *pDC = GetDC();

	pDC->Rectangle (0, 0, 520, 520);

	for(int i = 0; i<no_data; i++) {
		pDC->SetPixel((int)data[i].x, (int)data[i].y, RGB(255,0,0));
	}

	sLine line;
	double cost = ransac_line_fitting (data, no_data, line, 30);

	if (100. < cost) {
		pDC->MoveTo((int)(line.sx-500*line.mx), (int)(line.sy-500*line.my));
		pDC->LineTo((int)(line.sx+500*line.mx), (int)(line.sy+500*line.my));
	}

	delete [] data;
}
